# coding: utf-8
# GPIO ライブラリをインポート
import RPi.GPIO as GPIO

# time ライブラリをインポート
import time
# ピン番号の割り当て方式を「コネクタのピン番号」に設定
GPIO.setmode(GPIO.BOARD)
GPIO.setwarnings(False)
# 使用するピン番号を代入
PIN = [7,8,10,11,15,16,18,22]
PIN0= [0,4]
MASK = [0b1000, 0b0010, 0b0100, 0b0001,0b1000, 0b0010, 0b0100, 0b0001]
SPEED=0.005
# 各ピンを出力ピンに設定
for i in range(len(PIN)):
    GPIO.setup(PIN[i], GPIO.OUT, initial=GPIO.HIGH)
# Set servo on GPIO40 to 1200µs (1.2ms)
PIN_S=40
GPIO.setup(PIN_S, GPIO.OUT)
servo = GPIO.PWM(PIN_S, 50) 
servo.start(0.0)

# 出力信号パターンのリストを作成
SIG = [ 0b1000,
        0b1100,
        0b0100,
        0b0110,
        0b0010,
        0b0011,
        0b0001,
        0b1001 ]
CT=5
def south(c):
    for i in range(c):
                # step で指定したステップ数までループ
                step_count=0
                while step_count<8:
                    # 出力信号パターンを順番に出力
                    for i in range(4):
                        GPIO.output(PIN[i+PIN0[0]], SIG[step_count] & MASK[i])  
                        # 0.01 秒待つ
                        time.sleep(SPEED)
                        step_count=step_count+1
def north(c):
    for i in range(c):
                # step で指定したステップ数までループ
                step_count=7
                while step_count >=0:
                    # 出力信号パターンを順番に出力
                    for i in range(3,-1,-1):
                        GPIO.output(PIN[i+PIN0[0]], SIG[step_count] & MASK[i])  
                        # 0.01 秒待つ
                        time.sleep(SPEED)
                        step_count=step_count-1
def west(c):
    for i in range(c):
                # step で指定したステップ数までループ
                step_count=0
                while step_count<8:
                    # 出力信号パターンを順番に出力
                    for i in range(4):
                        GPIO.output(PIN[i+PIN0[1]], SIG[step_count] & MASK[i])  
                        # 0.01 秒待つ
                        time.sleep(SPEED)
                        step_count=step_count+1
def east(c):
    for i in range(c):
                # step で指定したステップ数までループ
                step_count=7
                while step_count >=0:
                    # 出力信号パターンを順番に出力
                    for i in range(3,-1,-1):
                        GPIO.output(PIN[i+PIN0[1]], SIG[step_count] & MASK[i])  
                        # 0.01 秒待つ
                        time.sleep(SPEED)
                        step_count=step_count-1
def penup():
    servo.ChangeDutyCycle(4.0)
    time.sleep(0.5)
def pendown():
    servo.ChangeDutyCycle(2.5)
    time.sleep(0.5)

# 例外を検出
try:
    # キーボード例外を検出
    x1=0
    x2=0 
    x3=10
    x4=0
    #pendown()
    north(x1)
    east(x2)
    south(x3)
    west(x4)
    #penup()


except KeyboardInterrupt:
    # 何も処理しない
    pass

# GPIO を解放
GPIO.cleanup()
